Crystal::EventLoop::Polling::Waiters - Crystal 1.20.1

# struct Crystal::EventLoop::Polling::Waiters

- Crystal::EventLoop::Polling::Waiters
- Struct
- Value
- Object

##
Overview

A FIFO queue of `Event` waiting on the same operation (either read or write) for a fd. See `PollDescriptor`.

Race conditions on the state of the waiting list are handled through the ready always ready variables.

Thread unsafe: parallel mutations must be protected with a lock.

##
Defined in:

crystal/event_loop/polling/waiters.cr

##
Constructors

- .new

##
Instance Method Summary

- #add(event : Pointer(Event)) : Bool

  Adds an event to the waiting list.

- #delete(event : Pointer(Event)) : Nil
- #initialize
- #ready_all(& : Pointer(Event) -> ) : Nil

  Dequeues all pending events and marks the list as always ready.

- #ready_one(& : Pointer(Event) -> Bool) : Nil

  Removes one pending event or marks the list as ready when there are no pending events (we got notified of readiness before a thread enqueued).

### Instance methods inherited from struct `Struct`

==(other : YAML::Any)
==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Class methods inherited from struct `Struct`

pre_initialize(address : Pointer) : Nil pre_initialize

### Instance methods inherited from struct `Value`

==(other : Log::Metadata::Value)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new #

##
Instance Method Detail

def add(event : Pointer(Event)) : Bool #

Adds an event to the waiting list. May return false immediately if another thread marked the list as ready in parallel, returns true otherwise.

def delete(event : Pointer(Event)) : Nil #
def initialize #
def ready_all(& : Pointer(Event) -> ) : Nil #

Dequeues all pending events and marks the list as always ready. This must be called when a fd is closed or an error or hup event occurred.

def ready_one(& : Pointer(Event) -> Bool) : Nil #

Removes one pending event or marks the list as ready when there are no pending events (we got notified of readiness before a thread enqueued).